APIGatewayResource:
  Type: "AWS::ApiGateway::RestApi"
  Properties:
    Name: "RestAPI"
    Description: "AWS RESTful API for Lambda integration."

APIGatewayResourceHello:
  Type: "AWS::ApiGateway::Resource"
  Properties:
    ParentId: !GetAtt APIGatewayResource.RootResourceId
    PathPart: "hello"
    RestApiId: !Ref "APIGatewayResource"

APIGatewayResourceHelloMethodIntegration:
  Type: 'AWS::ApiGateway::Method'
  Properties:
    AuthorizationType: NONE
    HttpMethod: POST
    Integration:
      Credentials: !GetAtt  APIExecutionRole.Arn                       
      Type: "AWS_PROXY"
      IntegrationHttpMethod: POST          
      Uri: !Sub
        - "arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${lambdaArn}/invocations"
        - lambdaArn: !GetAtt "HelloWorldLambdFunction.Arn"  
      IntegrationResponses:
        - StatusCode: 200
          ResponseTemplates:
            application/json: ''
          ResponseParameters:
              method.response.header.Access-Control-Allow-Headers: "'*'"
              method.response.header.Access-Control-Allow-Methods: "'POST,OPTIONS'"
              method.response.header.Access-Control-Allow-Origin: "'*'"
              method.response.header.Access-Control-Allow-Credentials:  "'*'"
      RequestTemplates:
        application/json: $input.json('$')
    ResourceId: !Ref APIGatewayResourceHello
    RestApiId: !Ref APIGatewayResource
    MethodResponses:
      - ResponseModels:
          application/json: Empty
        ResponseParameters:
          method.response.header.Access-Control-Allow-Headers: true
          method.response.header.Access-Control-Allow-Methods: true
          method.response.header.Access-Control-Allow-Origin: true
          method.response.header.Access-Control-Allow-Credentials: true
        StatusCode: '200'

APIGatewayResourceHelloMethodIntegrationEnableCORS:
  Type: "AWS::ApiGateway::Method"
  Properties:
    ResourceId: !Ref APIGatewayResourceHello
    RestApiId: !Ref APIGatewayResource
    AuthorizationType: NONE
    HttpMethod: OPTIONS
    Integration:
      Credentials: !GetAtt APIExecutionRole.Arn
      Type: MOCK
      IntegrationResponses:
        - ResponseParameters:
            method.response.header.Access-Control-Allow-Headers: "'*'"
            method.response.header.Access-Control-Allow-Methods: "'POST,OPTIONS'"
            method.response.header.Access-Control-Allow-Origin: "'*'"        
            method.response.header.Access-Control-Allow-Credentials:  "'*'"
          ResponseTemplates:
            application/json: ''
          StatusCode: '200'
      PassthroughBehavior: WHEN_NO_MATCH
      RequestTemplates:
        application/json: '{"statusCode": 200}'
    MethodResponses:
      - ResponseModels:
          application/json: Empty
        ResponseParameters:
          method.response.header.Access-Control-Allow-Headers: true
          method.response.header.Access-Control-Allow-Methods: true
          method.response.header.Access-Control-Allow-Origin: true
          method.response.header.Access-Control-Allow-Credentials: true
        StatusCode: '200'

APIGatewayResourceDeployment:
  Type: "AWS::ApiGateway::Deployment"
  DependsOn: 
    - APIGatewayResourceHelloMethodIntegration
    - APIGatewayResourceHelloMethodIntegrationEnableCORS
  Properties:
    RestApiId: !Ref "APIGatewayResource"
    StageName: "test
